--
--
--		MapAmpeln_Kreuzung3er
--@date: 02/10/2012
--@Author: Bluebaby210		www.mod-portal.com
--@Version: v1.0
--
--darf in jede Map eingebaut werden, MapAmpeln.zip darf nicht neu hochgeladen werden
--
--Keine nderung ohne meine Erlaubnis
--No modification without my permission


	print("   Map: TrafficLights 3er v1.0 by Bluebaby210 loaded!");

function onCreateKreuzung3er(self, id)
	--print("created MapAmpeln3er, id: ", id);
	local Ampeln3 = kreuzung3er:new(g_server ~= nil, g_client ~= nil);
    local index = g_currentMission:addOnCreateLoadedObject(Ampeln3);
    Ampeln3:load(id);
    Ampeln3:register(true);
end;

kreuzung3er = {}
local kreuzung3er_mt = Class(kreuzung3er, Object);

function kreuzung3er:new(isServer, isClient)
    local self = Object:new(isServer, isClient, kreuzung3er_mt);
    self.className = "kreuzung3er";
    return self;
end;

function kreuzung3er:load(id)

	--Indexe der Lampen laden
	self.red31 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights3.1_Red"));
	self.red32 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights3.2_Red"));
	self.red33 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights3.3_Red"));

	self.orange31 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights3.1_Orange"));
	self.orange32 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights3.2_Orange"));
	self.orange33 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights3.3_Orange"));

	self.green31 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights3.1_Green"));
	self.green32 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights3.2_Green"));
	self.green33 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights3.3_Green"));
	
	
	--Collis Laden und collis hochsetzen sowie g_currentMission.nodeToVehicles setzen.
	self.colli31 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights3.1_Colli"));
	self.colli32 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights3.2_Colli"));
	self.colli33 = Utils.indexToObject(id, getUserAttribute(id, "TrafficLights3.3_Colli"));

	x31, y31, z31 = getTranslation(self.colli31);
	x32, y32, z32 = getTranslation(self.colli32);
	x33, y33, z33 = getTranslation(self.colli33);
		
	setTranslation(self.colli31,x31,0,z31);
	g_currentMission.nodeToVehicle[self.colli31] = {};
	setTranslation(self.colli32,x32,0,z32);
	g_currentMission.nodeToVehicle[self.colli32] = {};
	setTranslation(self.colli33,x33,0,z33);
	g_currentMission.nodeToVehicle[self.colli33] = {};

	--greenTime laden berprfen ob mich jemand "verarscht", zur not grnphasen an der falsch eingestellten Kreuzung gleich auf 5 sekunden setzen.
	self.greenTime31 = getUserAttribute(id, "TrafficLights3.1_greenTime");
	self.greenTime32 = getUserAttribute(id, "TrafficLights3.2_greenTime");
	self.greenTime33 = getUserAttribute(id, "TrafficLights3.3_greenTime");
	
	if self.greenTime31 < 5 or self.greenTime32 < 5 or self.greenTime33 < 5 then
		self.greenTime31 = 5;
		self.greenTime32 = 5;
		self.greenTime33 = 5;
		print ("Warning: Gruenphase in einer Ampel kleiner als 5Sek. oder nicht angegeben, Gruenphase in allen Ampeln der Kreuzung auf 5Sekunden gesetzt");
	end;

	--Timer grnphasen hochsetzen um Pausen fr die umschaltung der nchsten Ampel erstellen zu knnen. Sowie blinklicht timer fr ausgeschaltete ampeln laden.
	self.TimerGreen31 = (self.greenTime31 * 1000) + 10000;
	self.TimerGreen32 = (self.greenTime32 * 1000) + 6000;
	self.TimerGreen33 = (self.greenTime33 * 1000) + 2000;
	self.TimerGreen31Backup = self.TimerGreen31;
	self.TimerGreen32Backup = self.TimerGreen32;
	self.TimerGreen33Backup = self.TimerGreen33;
	self.TrafficLights32start = false;
	self.TrafficLights33start = false;
	self.sequenceIsInterrupted = true;
	self.orangeFlashing = true;
	self.orangeLightTimer = 2000;
	self.orangeLightTimerBackup = 2000;
	
	--Zeitsteuerung
	self.trafficLightsStartTime = getUserAttribute(id, "TrafficLights_start_time");
	if self.trafficLightsStartTime == 0 then
		self.trafficLightsStartTime = 0.01;
	end;
	self.trafficLightsEndTime = getUserAttribute(id, "TrafficLights_end_time");
	if self.trafficLightsEndTime == 0 then
		self.trafficLightsEndTime = 23.99;
	end;
	
	self.startTime = self.trafficLightsStartTime * 3600000;
	self.endTime = self.trafficLightsEndTime * 3600000;

	self.allowsControl = true;
		
	if self.isServer then
		if g_server.netIsRunning then
			self.allowsControl = false;
			globaleVariable = false;
			globaleTriggerVariable = false;
		end;
	end;
	
	if g_client.netIsRunning == true then
		self.allowsControl = false;
		globaleVariable = false;
		globaleTriggerVariable = false;
	end;
	
	self.MpStarted = 0;

end;

function kreuzung3er:delete()
end;

function kreuzung3er:mouseEvent(posX, posY, isDown, isUp, button)
end;

function kreuzung3er:keyEvent(unicode, sym, modifier, isDown)
end;

function kreuzung3er:TriggerCallback(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)

end;

function kreuzung3er:update(dt)

	if (g_currentMission.environment.dayTime > self.startTime and g_currentMission.environment.dayTime < self.endTime) then
		if globaleVariable then				--ampeln sind an, "globaleVariable" kommt aus dem Trigger skript
				self.orangeFlashing = true;					--wird gebraucht um beim abschalten alle collis runterzufahren und die Lampen auszuschalten, sowie alle Timer der Ampelphasen zurckzusetzen. 
			if self.sequenceIsInterrupted then					--wenn Ampeln ausgeschaltet waren, einmal durchlaufen um Ampel auf rot zu stellen und collis hochholen
				setVisibility(self.red31,true);
				setVisibility(self.red32,true);
				setVisibility(self.red33,true);
				setVisibility(self.orange31,false);
				setVisibility(self.orange32,false);
				setVisibility(self.orange33,false);
				setVisibility(self.green31,false);
				setVisibility(self.green32,false);
				setVisibility(self.green33,false);
				setTranslation(self.colli31,x31,0,z31);
				setTranslation(self.colli32,x32,0,z32);
				setTranslation(self.colli33,x33,0,z33);
				self.sequenceIsInterrupted = false;
			end;
			if self.TimerGreen31 >= 0 then					--1.Ampel startet mit durchlauf
				self.TimerGreen31 = self.TimerGreen31 - dt;
					if self.TimerGreen31 <= (self.TimerGreen31Backup - 4000) and self.TimerGreen31 >= (self.TimerGreen31Backup - 5000) then		--nach 4 sekunden pause, wird gelb fr eine sek gesetzt
						setVisibility(self.orange31,true);
					elseif self.TimerGreen31 <= (self.TimerGreen31Backup - 5000) and self.TimerGreen31 >= ((self.TimerGreen31Backup + 5000) - self.TimerGreen31Backup) then	--grnphase der ampel
						setVisibility(self.red31,false);
						setVisibility(self.orange31,false);
						setVisibility(self.green31,true);
						setTranslation(self.colli31,x31,-5,z31);
					elseif self.TimerGreen31 <= ((self.TimerGreen31Backup + 5000) - self.TimerGreen31Backup) and self.TimerGreen31 >= ((self.TimerGreen31Backup + 4000) - self.TimerGreen31Backup) then	--gelb
						setVisibility(self.green31,false);
						setVisibility(self.orange31,true);
					elseif self.TimerGreen31 <= ((self.TimerGreen31Backup + 4000) - self.TimerGreen31Backup) and self.TimerGreen31 >= 0 then	--4 sekunden rot, um kreuzung frei zu kriegen
						setVisibility(self.orange31,false);
						setVisibility(self.red31,true);
						setTranslation(self.colli31,x31,0,z31);
					elseif self.TimerGreen31 <= 0 then		--erst wenn Timer ganz abgelaufen kommt startbefehl fr 2.ampel
						self.TrafficLights32start = true;
					end;
				end;
			if self.TrafficLights32start then
				if self.TimerGreen32 >= 0 then
					self.TimerGreen32 = self.TimerGreen32 - dt;
						if self.TimerGreen32 <= self.TimerGreen32Backup and self.TimerGreen32 >= (self.TimerGreen32Backup - 1000) then		--1.sekunde gelb anzeigen
							setVisibility(self.orange32,true);
						elseif self.TimerGreen32 <= (self.TimerGreen32Backup - 1000) and self.TimerGreen32 >= ((self.TimerGreen32Backup + 5000) - self.TimerGreen32Backup) then	--grnphase
							setVisibility(self.red32,false);
							setVisibility(self.orange32,false);
							setVisibility(self.green32,true);
							setTranslation(self.colli32,x32,-5,z32);
						elseif self.TimerGreen32 <= ((self.TimerGreen32Backup + 5000) - self.TimerGreen32Backup) and self.TimerGreen32 >= ((self.TimerGreen32Backup + 4000) - self.TimerGreen32Backup) then --gelb
							setVisibility(self.green32,false);
							setVisibility(self.orange32,true);
						elseif self.TimerGreen32 <= ((self.TimerGreen32Backup + 4000) - self.TimerGreen32Backup) and self.TimerGreen32 >= 0 then	--4sekunden rot,  um kreuzung frei zu kriegen
							setVisibility(self.orange32,false);
							setVisibility(self.red32,true);
							setTranslation(self.colli32,x32,0,z32);
						elseif self.TimerGreen32 <= 0 then	--erst wenn timer 0, kommt befehl fr 3.Ampel
							self.TrafficLights33start = true;
							self.TrafficLights32start = false;
							self.TimerGreen32 = self.TimerGreen32Backup;
						end;
				end;
			end;
			if self.TrafficLights33start then
				if self.TimerGreen33 >= 0 then
					self.TimerGreen33 = self.TimerGreen33 - dt;
						if self.TimerGreen33 <= self.TimerGreen33Backup and self.TimerGreen33 >= (self.TimerGreen33Backup - 1000) then		--1.sekunde gelb anzeigen
							setVisibility(self.orange33,true);
						elseif self.TimerGreen33 <= (self.TimerGreen33Backup - 1000) and self.TimerGreen33 >= ((self.TimerGreen33Backup + 1000) - self.TimerGreen33Backup) then	--grnphase
							setVisibility(self.red33,false);
							setVisibility(self.orange33,false);
							setVisibility(self.green33,true);
							setTranslation(self.colli33,x33,-5,z33);
						elseif self.TimerGreen33 <= ((self.TimerGreen33Backup + 1000) - self.TimerGreen33Backup) and self.TimerGreen33 >= 0 then	--gelb
							setVisibility(self.green33,false);
							setVisibility(self.orange33,true);
						elseif self.TimerGreen33 <= 0 then		--keine 4 sekunden pause, da 4sekunden pause zu beginn der 1.Ampel gemacht werden, damit auch nach anschalten der ampeln 4 sek rot ist.
							setVisibility(self.orange33,false);
							setVisibility(self.red33,true);
							setTranslation(self.colli33,x33,0,z33);
							self.TrafficLights33start = false;
							self.TimerGreen31 = self.TimerGreen31Backup;
							self.TimerGreen33 = self.TimerGreen33Backup;
						end;
				end;
			end;

		end;
	 
		if globaleVariable == false then		--ampeln sind ausgeschaltet
			if self.orangeFlashing then			--einmal durchlaufen, dabei timer der ampeln zurcksetzen, collis runterfahren, lampen rot und grn ausschalten, sowie startbefehl fr Blinklicht geben, Timer setzen.
				self.TimerGreen31 = self.TimerGreen31Backup;
				self.TimerGreen32 = self.TimerGreen32Backup;
				self.TimerGreen33 = self.TimerGreen33Backup;
				self.TrafficLights32start = false;
				self.TrafficLights33start = false;
				setTranslation(self.colli31,x31,-5,z31);
				setTranslation(self.colli32,x32,-5,z32);
				setTranslation(self.colli33,x33,-5,z33);
				setVisibility(self.red31,false);
				setVisibility(self.red32,false);
				setVisibility(self.red33,false);
				setVisibility(self.green31,false);
				setVisibility(self.green32,false);
				setVisibility(self.green33,false);
				self.orangeFlashing = false;
				self.sequenceIsInterrupted = true;
				self.orangeLightTimer = self.orangeLightTimerBackup;
			end;
			if self.orangeFlashing == false then
				if self.orangeLightTimer >= 0 then		--Timer laufen lassen, 1sekunde an, 1.sek aus...Timer wieder zurcksetzen um neuen durchlauf zu starten
					self.orangeLightTimer = self.orangeLightTimer - dt;
					if self.orangeLightTimer <= 2000 and self.orangeLightTimer >= 1000 then
						setVisibility(self.orange31,false);
						setVisibility(self.orange32,false);
						setVisibility(self.orange33,false);
					elseif self.orangeLightTimer <= 1000 and self.orangeLightTimer >= 0 then
						setVisibility(self.orange31,true);
						setVisibility(self.orange32,true);
						setVisibility(self.orange33,true);
					elseif self.orangeLightTimer <= 0 then
						self.orangeLightTimer = self.orangeLightTimerBackup;
					end;
				end;
			end;
		end;
	elseif (g_currentMission.environment.dayTime >= self.endTime or g_currentMission.environment.dayTime <= self.startTime) then  
			if self.orangeFlashing then			--einmal durchlaufen, dabei timer der ampeln zurcksetzen, collis runterfahren, lampen rot und grn ausschalten, sowie startbefehl fr Blinklicht geben, Timer setzen.
				self.TimerGreen31 = self.TimerGreen31Backup;
				self.TimerGreen32 = self.TimerGreen32Backup;
				self.TimerGreen33 = self.TimerGreen33Backup;
				self.TrafficLights32start = false;
				self.TrafficLights33start = false;
				setTranslation(self.colli31,x31,-5,z31);
				setTranslation(self.colli32,x32,-5,z32);
				setTranslation(self.colli33,x33,-5,z33);
				setVisibility(self.red31,false);
				setVisibility(self.red32,false);
				setVisibility(self.red33,false);
				setVisibility(self.green31,false);
				setVisibility(self.green32,false);
				setVisibility(self.green33,false);
				self.orangeFlashing = false;
				self.sequenceIsInterrupted = true;
				self.orangeLightTimer = self.orangeLightTimerBackup;
			end;
			if self.orangeFlashing == false then
				if self.orangeLightTimer >= 0 then		--Timer laufen lassen, 1sekunde an, 1.sek aus...Timer wieder zurcksetzen um neuen durchlauf zu starten
					self.orangeLightTimer = self.orangeLightTimer - dt;
					if self.orangeLightTimer <= 2000 and self.orangeLightTimer >= 1000 then
						setVisibility(self.orange31,false);
						setVisibility(self.orange32,false);
						setVisibility(self.orange33,false);
					elseif self.orangeLightTimer <= 1000 and self.orangeLightTimer >= 0 then
						setVisibility(self.orange31,true);
						setVisibility(self.orange32,true);
						setVisibility(self.orange33,true);
					elseif self.orangeLightTimer <= 0 then
						self.orangeLightTimer = self.orangeLightTimerBackup;
					end;
				end;
			end;
		end;

	if not self.allowsControl then
		if self.MpStarted < 4000 then
			g_currentMission:addWarning(g_i18n:getText("Ampel_MP_W"));
			self.MpStarted = self.MpStarted + dt;
		end;
	end;

end;

function kreuzung3er:draw()
end;
addModEventListener(MapAmpelnkreuzung3er);


